﻿<%@ Page Language="C#" AutoEventWireup="true" %>

<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Drawing.Imaging" %>
<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.Net.Security" %>
<%@ Import Namespace="System.Security.Cryptography.X509Certificates" %>
<%@ Import Namespace="System.Text" %>
<%@ Import namespace="com.swivelsecure.pinsafe" %>

<script runat="server">
    protected void Page_Load(object sender, EventArgs e) {
        string username = Request["username"];
	    string padno = Request["padno"];
	    PINsafeSettings settings = new PINsafeSettings();
		if (String.IsNullOrEmpty(username) {
			return;
		}

        StringBuilder address = new StringBuilder();
		address.Append(settings.SSL ? "https://" : "http://");
		address.AppendFormat("{0}:{1}/{2}/SCPinPad?username=", settings.Server, settings.Port, settings.Context);
        address.Append(username);
		address.Append("&padno=");
		address.Append(padno);
        address.Append("&random=");
        address.Append(new Random().Next());
        string contentType;
		HttpWebRequest webRequest = (HttpWebRequest)WebRequest.Create(address.ToString());
        if (settings.AcceptSelfSigned) {
			ServicePointManager.ServerCertificateValidationCallback = DummyCertificateValidator;
        }
        HttpWebResponse webResponse = (HttpWebResponse)webRequest.GetResponse();
        HttpStatusCode status = webResponse.StatusCode;
        if (status == HttpStatusCode.OK) {
            MemoryStream strm = new MemoryStream();
            Stream respStream = webResponse.GetResponseStream();
            if (respStream != null) {
				const int bufSize = 0x400;
                byte[] buffer = new byte[bufSize];
                int bufLen = respStream.Read(buffer, 0, bufSize);
                while (bufLen > 0) {
                    strm.Write(buffer, 0, bufLen);
                    bufLen = respStream.Read(buffer, 0, bufSize);
                }
            }
            contentType = webResponse.ContentType;
            Image image = Image.FromStream(strm);
			Response.ContentType = "image/png";
			StringBuilder disposition = new StringBuilder("inline; filename=pinpad.png");
			Response.AddHeader("Content-Disposition", disposition.ToString());
		    image.Save(Response.OutputStream, ImageFormat.Png);
        } else {
			Response.StatusCode = status;
		}
		// Try and prevent caching
		Response.CacheControl = "private";
		Response.ExpiresAbsolute = new DateTime(1970, 1, 1);
		Response.AddHeader("Pragma", "no-cache");

		// Done
		Response.End();
    }

</script>